﻿using Microsoft.AspNetCore.Mvc;
using WebApi4.Model;

namespace WebApi4.Controller
{
    [Route("api/[controller]")]
    [ApiController]
    public class StudentController : ControllerBase
    {
        static List<Student> students = new List<Student>()
        {
            new Student("mppl21123","Eleni","el@yahoo.com"),
            new Student("mppl21321","Christos","c1@gmail.com"),
            new Student("mppl21007","Dionysios","dion@unipi.gr")
        };
        [HttpGet]
        [Route("allstudents")]
        public List<Student> GetStudents()
        {
            return students;
        }
        [HttpPost]
        [Route("newStudent")]
        public Student Post([FromBody] Student student)
        {
            students.Add(student);
            return student;
        }
        [HttpGet]
        [Route("findone/{AM}")]
        public Student Get(string AM)
        {
            Student? student = students.Find(s => s.AM == AM);
            if (student is not null)
            {
                return student;
            }
            return null;
        }
        [HttpDelete]
        [Route("deletestudent/{AM}")]
        public List<Student> Delete(String AM)
        {
            Student? student = students.Find(s => s.AM == AM);
            if (student is not null)
                students.Remove(student);
            return students;
        }
        [HttpPut]
        [Route("updatestudent/{AM}")]
        public Student Put(String AM, [FromBody] Student student)
        {
            Student? studentToUpdate = students.Find(s => s.AM == AM);
            if (studentToUpdate is not null)
            {
                int index = students.IndexOf(studentToUpdate);
                students.RemoveAt(index);
                students.Insert(index, student);
            }
            return student;
        }
    }
}
